/******************************************************************************
 * File         :   accel.c
 * Autore       :   Diego Mereghetti, Alessandro Marin
 * Descrizione  :   Applicazione di test per la connessione al wiimote e
 *                  per la lettura dei valori dell'accelerometro
 * Librerie     :   libbluetooth
 *                  libcwiimote
 *                  libm
 ******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "wiimote_api.h"

int main(int argc, char* argv[])
{
    wiimote_t wi;
    
    if ( argc < 2 )
    {
        printf("USAGE: %s <xx:xx:xx:xx:xx>\n", argv[0]);
        exit(0);
    }
    
    printf("Connecting to WiiMote at address: %s\n", argv[1]);
    wiimote_connect(&wi, argv[1]);
    
    // enable accelerometer
    wi.mode.acc = 1;

    while ( wiimote_is_open(&wi) )
    {
        wiimote_update(&wi); 	// synchronize with wiimote
        if ( wi.keys.home )
        {
            // check if home key is pressed
            wiimote_disconnect(&wi);
        }

        printf("x=%d y=%d z=%d\n", wi.axis.x, wi.axis.y, wi.axis.z);
    }

    return 0;
}
