/******************************************************************************
 * File         :   dump.c
 * Autore       :   Diego Mereghetti, Alessandro Marin
 * Descrizione  :   Applicazione per la creazione dei file per il riconoscimento
 *                  dei movimenti del gioco
 * Librerie     :   libbluetooth
 *                  libcwiimote
 *                  libm
 ******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "wiimote_api.h"


int main(int argc, char* argv[])
{
    wiimote_t wi;
    
    wiimote_connect(&wi, "00:1F:C5:79:DA:1B");
    wi.mode.acc = 1;
    
    fprintf(stderr, "Keep (A) key pressed for recording\n");

    while (wiimote_is_open(&wi))
    {
        wiimote_update(&wi);

        if ( wi.keys.a )
        {
            fprintf(stderr, "Recording start\n");
            break;
        }
        
        usleep(200000);
    }
    
    while (wiimote_is_open(&wi))
    {
        wiimote_update(&wi);

        printf("%u\t%u\t%u\n",
            wi.axis.x,
            wi.axis.y,
            wi.axis.z);

        if ( !wi.keys.a )
        {
            fflush(stdout);
            fprintf(stderr, "Recording end\n");
            break;
        }
        
        usleep(100000);
    }
    
    fprintf(stderr, "Done\n");
    return 0;
}
