/******************************************************************************
 * File         :   led.c
 * Autore       :   Diego Mereghetti, Alessandro Marin
 * Descrizione  :   Applicazione per il test manuale dei led montati sul robot
 ******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>


void printChar(unsigned char c);


int main()
{
    char            input;
    char            quit;
    unsigned char   stato;
    int             i;
    FILE*           fp;
    
    
    fp = fopen("/dev/ttyUSB0", "a+");
    // = fopen("test", "r+");
    if ( fp == NULL )
    {
        perror("fopen");
        exit(-1);
    }
    
    stato = 0;
    quit = 0;
    printChar(stato);
    
    do
    {	
        input = getchar();
        getchar();
        switch( input )
        {
            // Led rossi
            case '\\':
            stato = ((stato >> 3) << 3 ) + 0x00;
            break;

            case '1':
            stato = ((stato >> 3) << 3 ) + 0x01;
            break;

            case '2':
            stato = ((stato >> 3) << 3 ) + 0x02;
            break;

            case '3':
            stato = ((stato >> 3) << 3 ) + 0x03;
            break;

            case '4':
            stato = ((stato >> 3) << 3 ) + 0x04;
            break;

            // Led verde
            case 'v':
            if ( stato & 0x08 ) stato -= 0x08;
            else stato += 0x08;
            break;

            // led gialli
            case '7':
            if ( stato & 0x10 ) stato -= 0x10;
            else stato += 0x10;
            break;

            case '8':
            if ( stato & 0x20 ) stato -= 0x20;
            else stato += 0x20;
            break;

            case '9':
            if ( stato & 0x40 ) stato -= 0x40;
            else stato += 0x40;
            break;

            case '0':
            if ( stato & 0x80 ) stato -= 0x80;
            else stato += 0x80;
            break;

            // macro
            case 'r':
            for ( i = 0; i < 15; i++ )
            {
                stato = ((stato >> 3) << 3 ) + 0x00;	fwrite(&stato, 1, 1, fp);	fflush(fp);	usleep(90000);
                stato = ((stato >> 3) << 3 ) + 0x01;	fwrite(&stato, 1, 1, fp);	fflush(fp);	usleep(90000);
                stato = ((stato >> 3) << 3 ) + 0x02;	fwrite(&stato, 1, 1, fp);	fflush(fp);	usleep(90000);
                stato = ((stato >> 3) << 3 ) + 0x03;	fwrite(&stato, 1, 1, fp);	fflush(fp);	usleep(90000);
                stato = ((stato >> 3) << 3 ) + 0x04;	fwrite(&stato, 1, 1, fp);	fflush(fp);	usleep(90000);
                stato = ((stato >> 3) << 3 ) + 0x03;	fwrite(&stato, 1, 1, fp);	fflush(fp);	usleep(90000);
                stato = ((stato >> 3) << 3 ) + 0x02;	fwrite(&stato, 1, 1, fp);	fflush(fp);	usleep(90000);
                stato = ((stato >> 3) << 3 ) + 0x01;	fwrite(&stato, 1, 1, fp);	fflush(fp);	usleep(90000);
            }
            stato = ((stato >> 3) << 3 ) + 0x00;		fwrite(&stato, 1, 1, fp);	fflush(fp);	usleep(90000);
            break;

            case 'g':
            for ( i = 0; i < 15; i++ )
            {
                stato += 0x10;	fwrite(&stato, 1, 1, fp);	fflush(fp);	stato -= 0x10;	usleep(90000);
                stato += 0x20;	fwrite(&stato, 1, 1, fp);	fflush(fp);	stato -= 0x20;	usleep(90000);
                stato += 0x40;	fwrite(&stato, 1, 1, fp);	fflush(fp);	stato -= 0x40;	usleep(90000);
                stato += 0x80;	fwrite(&stato, 1, 1, fp);	fflush(fp);	stato -= 0x80;	usleep(90000);
            }
            break;

            // comando quit
            case 'q':
            quit = 1;
            break;

            default:
            break;
        }

        printChar(stato);
        if ( !quit )
        {
            fwrite(&stato, 1, 1, fp);
            fflush(fp);
        }
    } while( !quit );

    fclose(fp);

    return 0;
}


void printChar(unsigned char c)
{
    int i;

    for ( i = 7; i >= 0; i-- )
    {
        if ( ( c >> i ) & 0x01 ) printf("1");
        else printf("0");
        
        if ( ( i == 4 ) || ( i == 3 ) ) printf(" ");
    }
    printf("\n");
}
